package weka.confirmationMeasures;

public class AConfirmationMeasure extends ConfirmationMeasure {

	private static final long serialVersionUID = 4037583640388315490L;

	public AConfirmationMeasure(DivisionByZeroStrategy divisionByZeroStrategy) {
		super(divisionByZeroStrategy);
	}

	public static double computeMeasure(double a, double b, double c, double d, DivisionByZeroStrategy divisionByZeroStrategy) {
		if ((a + b == 0) || (b + d == 0) || (c + d == 0)) {
			return divisionByZeroStrategy.coerceValue(a, b, c, d);
		}
		
		double confirmation = a * d - b * c;
		if (confirmation > 0) {
			return confirmation / ((a + b) * (b + d));
		} else if (confirmation < 0) {
			return confirmation / ((b + d) * (c + d));
		} else {
			return 0;
		}
	}
	
	@Override
	protected double compute(double a, double b, double c, double d) {
		return computeMeasure(a, b, c, d, divisionByZeroStrategy);
	}
}
