package weka.confirmationMeasures;

public class C1ConfirmationMeasure extends ConfirmationMeasure {

	private static final long serialVersionUID = 7910600334884625317L;
	
	private static final double alpha = 0.5;
	private static final double beta = 0.5;

	public C1ConfirmationMeasure(DivisionByZeroStrategy divisionByZeroStrategy) {
		super(divisionByZeroStrategy);
	}

	@Override
	protected double compute(double a, double b, double c, double d) {
		double confirmation = a * d - b * c;
		
		if (confirmation > 0) {
			if (c == 0) {
				return alpha + beta * AConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);
			} else {
				return alpha * ZConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);
			}
		} else if (confirmation < 0) {
			if (a > 0) {
				return alpha * ZConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);
			} else {
				return -alpha + beta * AConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);
			}
		} else {
			return 0;
		}
	}
}
