package weka.confirmationMeasures;

public class C2ConfirmationMeasure extends ConfirmationMeasure {

	private static final long serialVersionUID = 8724629288246883300L;
	
	private static final double alpha = 0.5;
	private static final double beta = 0.5;

	public C2ConfirmationMeasure(DivisionByZeroStrategy divisionByZeroStrategy) {
		super(divisionByZeroStrategy);
	}

	@Override
	protected double compute(double a, double b, double c, double d) {
		double confirmation = a * d - b * c;
		
		if (confirmation > 0) {
			if (b == 0) {
				return alpha + beta * ZConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);
			} else {
				return alpha * AConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);
			}
		} else if (confirmation < 0) {
			if (d > 0) {
				return alpha * AConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);
			} else {
				return -alpha + beta * ZConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);
			}
		} else {
			return 0;
		}
	}

}
