package weka.confirmationMeasures;

public class C3ConfirmationMeasure extends ConfirmationMeasure {

	private static final long serialVersionUID = 5828329443257402637L;

	public C3ConfirmationMeasure(DivisionByZeroStrategy divisionByZeroStrategy) {
		super(divisionByZeroStrategy);
	}

	@Override
	protected double compute(double a, double b, double c, double d) {
		double confirmation = a * d - b * c;
		double aMeasure = AConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);;
		double zMeasure = ZConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);;
		
		if (confirmation > 0) {
			return aMeasure * zMeasure;
		} else if (confirmation < 0) {
			return -(aMeasure * zMeasure);
		} else {
			return 0;
		}
	}

}
