package weka.confirmationMeasures;

public class C4ConfirmationMeasure extends ConfirmationMeasure {

	private static final long serialVersionUID = 3676727697897146387L;

	public C4ConfirmationMeasure(DivisionByZeroStrategy divisionByZeroStrategy) {
		super(divisionByZeroStrategy);
	}

	@Override
	protected double compute(double a, double b, double c, double d) {
		double confirmation = a * d - b * c;
		double aMeasure = AConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);;
		double zMeasure = ZConfirmationMeasure.computeMeasure(a, b, c, d, divisionByZeroStrategy);;
		
		if (confirmation > 0) {
			return Double.min(aMeasure, zMeasure);
		} else if (confirmation < 0) {
			return Double.max(aMeasure, zMeasure);
		} else {
			return 0;
		}
	}

}
