package weka.confirmationMeasures;

import java.io.Serializable;

public abstract class ConfirmationMeasure implements Serializable {
	
	private static final long serialVersionUID = 3770299748627766299L;
	
	private double m_measureValue;
	
	protected DivisionByZeroStrategy divisionByZeroStrategy;
	
	
	public ConfirmationMeasure(DivisionByZeroStrategy divisionByZeroStrategy) {
		this.divisionByZeroStrategy = divisionByZeroStrategy;
	}

	public double getMeasureValue() {
		return m_measureValue;
	}
	
	public void computeMeasure(double a, double b, double c, double d) {
		m_measureValue = compute(a, b, c, d);
		
		if (m_measureValue > 1 || m_measureValue < -1) {
			throw new RuntimeException("Measure " + m_measureValue + " value is outside of the range <-1, 1>");
		}
	}

	protected abstract double compute(double a, double b, double c, double d);
}
