package weka.confirmationMeasures;

public class ZConfirmationMeasure extends ConfirmationMeasure {

	private static final long serialVersionUID = 6450958162946196469L;

	public ZConfirmationMeasure(DivisionByZeroStrategy divisionByZeroStrategy) {
		super(divisionByZeroStrategy);
	}

	public static double computeMeasure(double a, double b, double c, double d, DivisionByZeroStrategy divisionByZeroStrategy) {
		if ((a + c == 0) || (c + d == 0) || (a + b == 0)) {
			return divisionByZeroStrategy.coerceValue(a, b, c, d);
		}
		
		double confirmation = a * d - b * c;
		if (confirmation > 0) {
			return confirmation / ((a + c) * (c + d));
		} else if (confirmation < 0) {
			return confirmation / ((a + c) * (a + b));
		} else {
			return 0;
		}
	}
	
	@Override
	protected double compute(double a, double b, double c, double d) {
		return computeMeasure(a, b, c, d, divisionByZeroStrategy);
	}
}
